Index: /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm
===================================================================
--- /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50158)
+++ /trunk/src/VBox/Devices/PC/BIOS/VBoxBiosAlternative.asm	(revision 50159)
@@ -441,4 +441,22 @@
 ;   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA
 ;  
+
+;
+; Source file: invop.c
+;
+;  $Id$
+;  Real mode invalid opcode handler.
+;  
+;  
+;  
+;  Copyright (C) 2013 Oracle Corporation
+;  
+;  This file is part of VirtualBox Open Source Edition (OSE), as
+;  available from http://www.virtualbox.org. This file is free software;
+;  you can redistribute it and/or modify it under the terms of the GNU
+;  General Public License (GPL) as published by the Free Software
+;  Foundation, in version 2 as it comes in the "COPYING" file of the
+;  VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+;  hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
 
 ;
@@ -821,10 +839,10 @@
     db  001h, 000h, 002h, 002h, 003h, 003h, 004h, 004h, 005h, 005h, 00eh, 006h, 00fh, 006h, 000h
 _pktacc:                                     ; 0xf006a LB 0xc
-    db  000h, 000h, 000h, 000h, 000h, 000h, 02ah, 028h, 038h, 077h, 08eh, 084h
+    db  000h, 000h, 000h, 000h, 000h, 000h, 03fh, 028h, 0ech, 078h, 0b4h, 086h
 _softrst:                                    ; 0xf0076 LB 0xc
-    db  000h, 000h, 000h, 000h, 000h, 000h, 012h, 02bh, 022h, 036h, 022h, 036h
+    db  000h, 000h, 000h, 000h, 000h, 000h, 027h, 02bh, 041h, 036h, 041h, 036h
 _dskacc:                                     ; 0xf0082 LB 0x2e
-    db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 073h, 027h, 0edh, 027h, 000h, 000h, 000h, 000h
-    db  0cch, 075h, 082h, 076h, 08ah, 083h, 01eh, 084h, 000h, 000h, 000h, 000h, 000h, 000h, 05fh, 033h
+    db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 088h, 027h, 002h, 028h, 000h, 000h, 000h, 000h
+    db  080h, 077h, 036h, 078h, 0b0h, 085h, 044h, 086h, 000h, 000h, 000h, 000h, 000h, 000h, 05fh, 033h
     db  032h, 05fh, 000h, 0dah, 00fh, 000h, 000h, 001h, 0f3h, 000h, 000h, 000h, 000h, 000h
 
@@ -945,18 +963,18 @@
     db   'PCI: Unsupported function AX=%04X BX=%04X called', 00ah, 000h
 
-section CONST2 progbits vstart=0xd90 align=1 ; size=0x3fe class=DATA group=DGROUP
-_bios_cvs_version_string:                    ; 0xf0d90 LB 0x16
-    db  'VirtualBox 4.3.0_RC1', 000h, 000h
-_bios_prefix_string:                         ; 0xf0da6 LB 0x8
+section CONST2 progbits vstart=0xd90 align=1 ; size=0x3fa class=DATA group=DGROUP
+_bios_cvs_version_string:                    ; 0xf0d90 LB 0x12
+    db  'VirtualBox 4.3.53', 000h
+_bios_prefix_string:                         ; 0xf0da2 LB 0x8
     db  'BIOS: ', 000h, 000h
-_isotag:                                     ; 0xf0dae LB 0x6
+_isotag:                                     ; 0xf0daa LB 0x6
     db  'CD001', 000h
-_eltorito:                                   ; 0xf0db4 LB 0x18
+_eltorito:                                   ; 0xf0db0 LB 0x18
     db  'EL TORITO SPECIFICATION', 000h
-_drivetypes:                                 ; 0xf0dcc LB 0x28
+_drivetypes:                                 ; 0xf0dc8 LB 0x28
     db  046h, 06ch, 06fh, 070h, 070h, 079h, 000h, 000h, 000h, 000h, 048h, 061h, 072h, 064h, 020h, 044h
     db  069h, 073h, 06bh, 000h, 043h, 044h, 02dh, 052h, 04fh, 04dh, 000h, 000h, 000h, 000h, 04ch, 041h
     db  04eh, 000h, 000h, 000h, 000h, 000h, 000h, 000h
-_scan_to_scanascii:                          ; 0xf0df4 LB 0x37a
+_scan_to_scanascii:                          ; 0xf0df0 LB 0x37a
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 01bh, 001h, 01bh, 001h, 01bh, 001h
     db  000h, 001h, 000h, 000h, 031h, 002h, 021h, 002h, 000h, 000h, 000h, 078h, 000h, 000h, 032h, 003h
@@ -1015,11 +1033,11 @@
     db  000h, 000h, 000h, 000h, 000h, 000h, 000h, 085h, 000h, 087h, 000h, 089h, 000h, 08bh, 000h, 000h
     db  000h, 086h, 000h, 088h, 000h, 08ah, 000h, 08ch, 000h, 000h
-_panic_msg_keyb_buffer_full:                 ; 0xf116e LB 0x20
+_panic_msg_keyb_buffer_full:                 ; 0xf116a LB 0x20
     db  '%s: keyboard input buffer full', 00ah, 000h
 
-  ; Padding 0x472 bytes at 0xf118e
-  times 1138 db 0
+  ; Padding 0x476 bytes at 0xf118a
+  times 1142 db 0
 
-section _TEXT progbits vstart=0x1600 align=1 ; size=0x7cd5 class=CODE group=AUTO
+section _TEXT progbits vstart=0x1600 align=1 ; size=0x7ef5 class=CODE group=AUTO
 read_byte_:                                  ; 0xf1600 LB 0xe
     push bx                                   ; 53
@@ -1084,11 +1102,16 @@
     pop si                                    ; 5e
     retn                                      ; c3
-inb_cmos_:                                   ; 0xf165c LB 0x14
+inb_cmos_:                                   ; 0xf165c LB 0x1d
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
     push dx                                   ; 52
-    mov dx, strict word 00070h                ; ba 70 00
-    out DX, AL                                ; ee
-    mov dx, strict word 00071h                ; ba 71 00
+    mov AH, strict byte 070h                  ; b4 70
+    cmp AL, strict byte 080h                  ; 3c 80
+    jc short 01668h                           ; 72 02
+    mov AH, strict byte 072h                  ; b4 72
+    movzx dx, ah                              ; 0f b6 d4
+    out DX, AL                                ; ee
+    movzx dx, ah                              ; 0f b6 d4
+    inc dx                                    ; 42
     in AL, DX                                 ; ec
     db  02ah, 0e4h
@@ -1098,17 +1121,24 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-outb_cmos_:                                  ; 0xf1670 LB 0x13
+outb_cmos_:                                  ; 0xf1679 LB 0x1f
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
+    push bx                                   ; 53
     mov ah, dl                                ; 88 d4
-    mov dx, strict word 00070h                ; ba 70 00
-    out DX, AL                                ; ee
+    mov BL, strict byte 070h                  ; b3 70
+    cmp AL, strict byte 080h                  ; 3c 80
+    jc short 01687h                           ; 72 02
+    mov BL, strict byte 072h                  ; b3 72
+    movzx dx, bl                              ; 0f b6 d3
+    out DX, AL                                ; ee
+    movzx dx, bl                              ; 0f b6 d3
+    inc dx                                    ; 42
     mov al, ah                                ; 88 e0
-    mov dx, strict word 00071h                ; ba 71 00
-    out DX, AL                                ; ee
-    mov sp, bp                                ; 89 ec
+    out DX, AL                                ; ee
+    lea sp, [bp-002h]                         ; 8d 66 fe
+    pop bx                                    ; 5b
     pop bp                                    ; 5d
     retn                                      ; c3
-_dummy_isr_function:                         ; 0xf1683 LB 0x6b
+_dummy_isr_function:                         ; 0xf1698 LB 0x6b
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -1124,5 +1154,5 @@
     mov byte [bp-002h], al                    ; 88 46 fe
     test al, al                               ; 84 c0
-    je short 016deh                           ; 74 43
+    je short 016f3h                           ; 74 43
     mov AL, strict byte 00bh                  ; b0 0b
     mov dx, 000a0h                            ; ba a0 00
@@ -1133,5 +1163,5 @@
     mov cx, ax                                ; 89 c1
     test al, al                               ; 84 c0
-    je short 016c0h                           ; 74 16
+    je short 016d5h                           ; 74 16
     mov dx, 000a1h                            ; ba a1 00
     in AL, DX                                 ; ec
@@ -1145,5 +1175,5 @@
     mov dx, 000a0h                            ; ba a0 00
     out DX, AL                                ; ee
-    jmp short 016d5h                          ; eb 15
+    jmp short 016eah                          ; eb 15
     mov dx, strict word 00021h                ; ba 21 00
     in AL, DX                                 ; ec
@@ -1163,65 +1193,65 @@
     mov dx, strict word 0006bh                ; ba 6b 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0160eh                               ; e8 24 ff
+    call 0160eh                               ; e8 0f ff
     mov sp, bp                                ; 89 ec
     pop bp                                    ; 5d
     retn                                      ; c3
-_nmi_handler_msg:                            ; 0xf16ee LB 0x12
+_nmi_handler_msg:                            ; 0xf1703 LB 0x12
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
     push 000b0h                               ; 68 b0 00
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 14 02
+    call 01922h                               ; e8 14 02
     add sp, strict byte 00004h                ; 83 c4 04
     mov sp, bp                                ; 89 ec
     pop bp                                    ; 5d
     retn                                      ; c3
-_int18_panic_msg:                            ; 0xf1700 LB 0x12
+_int18_panic_msg:                            ; 0xf1715 LB 0x12
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
     push 000c4h                               ; 68 c4 00
     push strict byte 00007h                   ; 6a 07
-    call 0190dh                               ; e8 02 02
+    call 01922h                               ; e8 02 02
     add sp, strict byte 00004h                ; 83 c4 04
     mov sp, bp                                ; 89 ec
     pop bp                                    ; 5d
     retn                                      ; c3
-_log_bios_start:                             ; 0xf1712 LB 0x20
+_log_bios_start:                             ; 0xf1727 LB 0x20
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
-    mov bx, 00da6h                            ; bb a6 0d
+    mov bx, 00da2h                            ; bb a2 0d
     mov cx, ds                                ; 8c d9
     mov ax, strict word 00004h                ; b8 04 00
-    call 018cch                               ; e8 ac 01
+    call 018e1h                               ; e8 ac 01
     push 00d90h                               ; 68 90 0d
     push 000d9h                               ; 68 d9 00
     push strict byte 00004h                   ; 6a 04
-    call 0190dh                               ; e8 e2 01
+    call 01922h                               ; e8 e2 01
     add sp, strict byte 00006h                ; 83 c4 06
     mov sp, bp                                ; 89 ec
     pop bp                                    ; 5d
     retn                                      ; c3
-_print_bios_banner:                          ; 0xf1732 LB 0x2e
+_print_bios_banner:                          ; 0xf1747 LB 0x2e
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
     mov dx, strict word 00072h                ; ba 72 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0161ch                               ; e8 de fe
+    call 0161ch                               ; e8 c9 fe
     mov cx, ax                                ; 89 c1
     xor bx, bx                                ; 31 db
     mov dx, strict word 00072h                ; ba 72 00
     mov ax, strict word 00040h                ; b8 40 00
-    call 0162ah                               ; e8 df fe
+    call 0162ah                               ; e8 ca fe
     cmp cx, 01234h                            ; 81 f9 34 12
-    jne short 01759h                          ; 75 08
+    jne short 0176eh                          ; 75 08
     mov AL, strict byte 003h                  ; b0 03
     mov AH, strict byte 000h                  ; b4 00
     int 010h                                  ; cd 10
-    jmp short 0175ch                          ; eb 03
-    call 071dbh                               ; e8 7f 5a
+    jmp short 01771h                          ; eb 03
+    call 0738fh                               ; e8 1e 5c
     mov sp, bp                                ; 89 ec
     pop bp                                    ; 5d
     retn                                      ; c3
-send_:                                       ; 0xf1760 LB 0x3b
+send_:                                       ; 0xf1775 LB 0x3b
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -1231,17 +1261,17 @@
     mov cl, dl                                ; 88 d1
     test AL, strict byte 008h                 ; a8 08
-    je short 01773h                           ; 74 06
+    je short 01788h                           ; 74 06
     mov al, dl                                ; 88 d0
     mov dx, 00403h                            ; ba 03 04
     out DX, AL                                ; ee
     test bl, 004h                             ; f6 c3 04
-    je short 0177eh                           ; 74 06
+    je short 01793h                           ; 74 06
     mov al, cl                                ; 88 c8
     mov dx, 00504h                            ; ba 04 05
     out DX, AL                                ; ee
     test bl, 002h                             ; f6 c3 02
-    je short 01794h                           ; 74 11
+    je short 017a9h                           ; 74 11
     cmp cl, 00ah                              ; 80 f9 0a
-    jne short 0178eh                          ; 75 06
+    jne short 017a3h                          ; 75 06
     mov AL, strict byte 00dh                  ; b0 0d
     mov AH, strict byte 00eh                  ; b4 0e
@@ -1255,5 +1285,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-put_int_:                                    ; 0xf179b LB 0x5f
+put_int_:                                    ; 0xf17b0 LB 0x5f
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -1270,22 +1300,22 @@
     mov word [bp-006h], ax                    ; 89 46 fa
     test ax, ax                               ; 85 c0
-    je short 017c0h                           ; 74 0a
+    je short 017d5h                           ; 74 0a
     dec bx                                    ; 4b
     mov dx, ax                                ; 89 c2
     mov ax, si                                ; 89 f0
-    call 0179bh                               ; e8 dd ff
-    jmp short 017dbh                          ; eb 1b
+    call 017b0h                               ; e8 dd ff
+    jmp short 017f0h                          ; eb 1b
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jle short 017cfh                          ; 7e 0a
+    jle short 017e4h                          ; 7e 0a
     mov dx, strict word 00020h                ; ba 20 00
     mov ax, si                                ; 89 f0
-    call 01760h                               ; e8 93 ff
-    jmp short 017c0h                          ; eb f1
+    call 01775h                               ; e8 93 ff
+    jmp short 017d5h                          ; eb f1
     test cx, cx                               ; 85 c9
-    je short 017dbh                           ; 74 08
+    je short 017f0h                           ; 74 08
     mov dx, strict word 0002dh                ; ba 2d 00
     mov ax, si                                ; 89 f0
-    call 01760h                               ; e8 85 ff
+    call 01775h                               ; e8 85 ff
     mov al, byte [bp-006h]                    ; 8a 46 fa
     mov DL, strict byte 00ah                  ; b2 0a
@@ -1297,5 +1327,5 @@
     movzx dx, al                              ; 0f b6 d0
     mov ax, si                                ; 89 f0
-    call 01760h                               ; e8 6d ff
+    call 01775h                               ; e8 6d ff
     lea sp, [bp-004h]                         ; 8d 66 fc
     pop di                                    ; 5f
@@ -1303,5 +1333,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-put_uint_:                                   ; 0xf17fa LB 0x60
+put_uint_:                                   ; 0xf180f LB 0x60
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -1318,22 +1348,22 @@
     mov word [bp-006h], ax                    ; 89 46 fa
     test ax, ax                               ; 85 c0
-    je short 01820h                           ; 74 0a
+    je short 01835h                           ; 74 0a
     dec bx                                    ; 4b
     mov dx, ax                                ; 89 c2
     mov ax, si                                ; 89 f0
-    call 017fah                               ; e8 dc ff
-    jmp short 0183bh                          ; eb 1b
+    call 0180fh                               ; e8 dc ff
+    jmp short 01850h                          ; eb 1b
     dec bx                                    ; 4b
     test bx, bx                               ; 85 db
-    jle short 0182fh                          ; 7e 0a
+    jle short 01844h                          ; 7e 0a
     mov dx, strict word 00020h                ; ba 20 00
     mov ax, si                                ; 89 f0
-    call 01760h                               ; e8 33 ff
-    jmp short 01820h                          ; eb f1
+    call 01775h                               ; e8 33 ff
+    jmp short 01835h                          ; eb f1
     test cx, cx                               ; 85 c9
-    je short 0183bh                           ; 74 08
+    je short 01850h                           ; 74 08
     mov dx, strict word 0002dh                ; ba 2d 00
     mov ax, si                                ; 89 f0
-    call 01760h                               ; e8 25 ff
+    call 01775h                               ; e8 25 ff
     mov al, byte [bp-006h]                    ; 8a 46 fa
     mov DL, strict byte 00ah                  ; b2 0a
@@ -1345,5 +1375,5 @@
     movzx dx, al                              ; 0f b6 d0
     mov ax, si                                ; 89 f0
-    call 01760h                               ; e8 0d ff
+    call 01775h                               ; e8 0d ff
     lea sp, [bp-004h]                         ; 8d 66 fc
     pop di                                    ; 5f
@@ -1351,5 +1381,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-put_luint_:                                  ; 0xf185a LB 0x72
+put_luint_:                                  ; 0xf186f LB 0x72
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -1365,28 +1395,28 @@
     mov bx, strict word 0000ah                ; bb 0a 00
     xor cx, cx                                ; 31 c9
-    call 091e0h                               ; e8 6c 79
+    call 09400h                               ; e8 77 7b
     mov word [bp-008h], ax                    ; 89 46 f8
     mov cx, dx                                ; 89 d1
     mov dx, ax                                ; 89 c2
     or dx, cx                                 ; 09 ca
-    je short 0188eh                           ; 74 0f
+    je short 018a3h                           ; 74 0f
     push word [bp+004h]                       ; ff 76 04
     lea dx, [di-001h]                         ; 8d 55 ff
     mov bx, ax                                ; 89 c3
     mov ax, si                                ; 89 f0
-    call 0185ah                               ; e8 ce ff
-    jmp short 018abh                          ; eb 1d
+    call 0186fh                               ; e8 ce ff
+    jmp short 018c0h                          ; eb 1d
     dec di                                    ; 4f
     test di, di                               ; 85 ff
-    jle short 0189dh                          ; 7e 0a
+    jle short 018b2h                          ; 7e 0a
     mov dx, strict word 00020h                ; ba 20 00
     mov ax, si                                ; 89 f0
-    call 01760h                               ; e8 c5 fe
-    jmp short 0188eh                          ; eb f1
+    call 01775h                               ; e8 c5 fe
+    jmp short 018a3h                          ; eb f1
     cmp word [bp+004h], strict byte 00000h    ; 83 7e 04 00
-    je short 018abh                           ; 74 08
+    je short 018c0h                           ; 74 08
     mov dx, strict word 0002dh                ; ba 2d 00
     mov ax, si                                ; 89 f0
-    call 01760h                               ; e8 b5 fe
+    call 01775h                               ; e8 b5 fe
     mov al, byte [bp-008h]                    ; 8a 46 f8
     mov DL, strict byte 00ah                  ; b2 0a
@@ -1398,5 +1428,5 @@
     movzx dx, al                              ; 0f b6 d0
     mov ax, si                                ; 89 f0
-    call 01760h                               ; e8 9d fe
+    call 01775h                               ; e8 9d fe
     lea sp, [bp-004h]                         ; 8d 66 fc
     pop di                                    ; 5f
@@ -1404,5 +1434,5 @@
     pop bp                                    ; 5d
     retn 00002h                               ; c2 02 00
-put_str_:                                    ; 0xf18cc LB 0x21
+put_str_:                                    ; 0xf18e1 LB 0x21
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -1413,10 +1443,10 @@
     mov dl, byte [es:bx]                      ; 26 8a 17
     test dl, dl                               ; 84 d2
-    je short 018e6h                           ; 74 0a
+    je short 018fbh                           ; 74 0a
     xor dh, dh                                ; 30 f6
     mov ax, si                                ; 89 f0
-    call 01760h                               ; e8 7d fe
+    call 01775h                               ; e8 7d fe
     inc bx                                    ; 43
-    jmp short 018d3h                          ; eb ed
+    jmp short 018e8h                          ; eb ed
     lea sp, [bp-004h]                         ; 8d 66 fc
     pop si                                    ; 5e
@@ -1424,5 +1454,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-put_str_near_:                               ; 0xf18ed LB 0x20
+put_str_near_:                               ; 0xf1902 LB 0x20
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -1433,10 +1463,10 @@
     mov dl, byte [bx]                         ; 8a 17
     test dl, dl                               ; 84 d2
-    je short 01906h                           ; 74 0a
+    je short 0191bh                           ; 74 0a
     xor dh, dh                                ; 30 f6
     mov ax, cx                                ; 89 c8
-    call 01760h                               ; e8 5d fe
+    call 01775h                               ; e8 5d fe
     inc bx                                    ; 43
-    jmp short 018f6h                          ; eb f0
+    jmp short 0190bh                          ; eb f0
     lea sp, [bp-004h]                         ; 8d 66 fc
     pop cx                                    ; 59
@@ -1444,5 +1474,5 @@
     pop bp                                    ; 5d
     retn                                      ; c3
-bios_printf_:                                ; 0xf190d LB 0x23b
+bios_printf_:                                ; 0xf1922 LB 0x23b
     push bp                                   ; 55
     mov bp, sp                                ; 89 e5
@@ -1461,29 +1491,29 @@
     and ax, strict word 00007h                ; 25 07 00
     cmp ax, strict word 00007h                ; 3d 07 00
-    jne short 0193bh                          ; 75 0b
+    jne short 01950h                          ; 75 0b
     push 000deh                               ; 68 de 00
     push strict byte 00002h                   ; 6a 02
-    call 0190dh                               ; e8 d5 ff
+    call 01922h                               ; e8 d5 ff
     add sp, strict byte 00004h                ; 83 c4 04
     mov bx, word [bp+006h]                    ; 8b 5e 06
     mov dl, byte [bx]                         ; 8a 17
     test dl, dl                               ; 84 d2
-    je near 01b2ch                            ; 0f 84 e6 01
+    je near 01b41h                            ; 0f 84 e6 01
     cmp dl, 025h                              ; 80 fa 25
-    jne short 01953h                          ; 75 08
+    jne short 01968h                          ; 75 08
     mov cx, strict word 00001h                ; b9 01 00
     xor si, si                                ; 31 f6
-    jmp near 01b26h                           ; e9 d3 01
+    jmp near 01b3bh                           ; e9 d3 01
     test cx, cx                               ; 85 c9
-    je near 01b1eh                            ; 0f 84 c5 01
+    je near 01b33h                            ; 0f 84 c5 01
     cmp dl, 030h                              ; 80 fa 30
-    jc short 01971h                           ; 72 13
+    jc short 01986h                           ; 72 13
     cmp dl, 039h                              ; 80 fa 39
-    jnbe short 01971h                         ; 77 0e
+    jnbe short 01986h                         ; 77 0e
     movzx ax, dl                              ; 0f b6 c2
     imul si, si, strict byte 0000ah           ; 6b f6 0a
     sub ax, strict word 00030h                ; 2d 30 00
     add si, ax                                ; 01 c6
-    jmp near 01b26h                           ; e9 b5 01
+    jmp near 01b3bh                           ; e9 b5 01
     mov ax, word [bp-010h]                    ; 8b 46 f0
     mov word [bp-010h], ax                    ; 89 46 f0
@@ -1493,18 +1523,18 @@
     mov word [bp-00ch], ax                    ; 89 46 f4
     cmp dl, 078h                              ; 80 fa 78
-    je short 0198fh                           ; 74 05
+    je short 019a4h                           ; 74 05
     cmp dl, 058h                              ; 80 fa 58
-    jne short 019d8h                          ; 75 49
+    jne short 019edh                          ; 75 49
     test si, si                               ; 85 f6
-    jne short 01996h                          ; 75 03
+    jne short 019abh                          ; 75 03
     mov si, strict word 00004h                ; be 04 00
     cmp dl, 078h                              ; 80 fa 78
-    jne short 019a0h                          ; 75 05
+    jne short 019b5h                          ; 75 05
     mov di, strict word 00061h                ; bf 61 00
-    jmp short 019a3h                          ; eb 03
+    jmp short 019b8h                          ; eb 03
     mov di, strict word 00041h                ; bf 41 00
     lea bx, [si-001h]                         ; 8d 5c ff
     test bx, bx                               ; 85 db
-    jl near 01b1ah                            ; 0f 8c 6e 01
+    jl near 01b2fh                            ; 0f 8c 6e 01
     mov cx, bx                                ; 89 d9
     sal cx, 002h                              ; c1 e1 02
@@ -1514,8 +1544,8 @@
     and AL, strict byte 00fh                  ; 24 0f
     cmp ax, strict word 00009h                ; 3d 09 00
-    jnbe short 019c6h                         ; 77 07
+    jnbe short 019dbh                         ; 77 07
     mov dx, ax                                ; 89 c2
     add dx, strict byte 00030h                ; 83 c2 30
-    jmp short 019cdh                          ; eb 07
+    jmp short 019e2h                          ; eb 07
     mov dx, ax                                ; 89 c2
     sub dx, strict byte 0000ah                ; 83 ea 0a
@@ -1523,18 +1553,18 @@
     xor dh, dh                                ; 30 f6
     mov ax, word [bp+004h]                    ; 8b 46 04
-    call 01760h                               ; e8 8b fd
+    call 01775h                               ; e8 8b fd
     dec bx                                    ; 4b
-    jmp short 019a6h                          ; eb ce
+    jmp short 019bbh                          ; eb ce
     cmp dl, 075h                              ; 80 fa 75
-    jne short 019ech                          ; 75 0f
+    jne short 01a01h                          ; 75 0f
     xor cx, cx                                ; 31 c9
     mov bx, si                                ; 89 f3
     mov dx, ax                                ; 89 c2
     mov ax, word [bp+004h]                    ; 8b 46 04
-    call 017fah                               ; e8 11 fe
-    jmp near 01b1ah                           ; e9 2e 01
+    call 0180fh                               ; e8 11 fe
+    jmp near 01b2fh                           ; e9 2e 01
     lea bx, [si-001h]                         ; 8d 5c ff
     cmp dl, 06ch                              ; 80 fa 6c
-    jne near 01aa8h                           ; 0f 85 b2 00
+    jne near 01abdh                           ; 0f 85 b2 00
     inc word [bp+006h]                        ; ff 46 06
     mov di, word [bp+006h]                    ; 8b 7e 06
@@ -1547,7 +1577,7 @@
     mov word [bp-00eh], ax                    ; 89 46 f2
     cmp dl, 064h                              ; 80 fa 64
-    jne short 01a44h                          ; 75 2d
+    jne short 01a59h                          ; 75 2d
     test byte [bp-00dh], 080h                 ; f6 46 f3 80
-    je short 01a32h                           ; 74 15
+    je short 01a47h                           ; 74 15
     push strict byte 00001h                   ; 6a 01
     mov ax, word [bp-00ch]                    ; 8b 46 f4
@@ -1558,5 +1588,5 @@
     mov dx, bx                                ; 89 da
     mov bx, ax                                ; 89 c3
-    jmp short 01a3bh                          ; eb 09
+    jmp short 01a50h                          ; eb 09
     push strict byte 00000h                   ; 6a 00
     mov bx, word [bp-00ch]                    ; 8b 5e f4
